<template>
  <div id="app">
    <!--케밥 케이스-->
    <todo-header></todo-header>
    <todo-input v-on:addTodoOne="addTodo"></todo-input>
    <todo-list
      v-bind:todoItems="todoItems"
      v-on:removeItem="removeTodo"
      v-on:toggleItem="toggleComplete"
    ></todo-list>
    <todo-footer v-on:clearItem="clearTodo"></todo-footer>
  </div>
</template>

<script>
import TodoHeader from "./components/TodoHeader.vue";
import TodoInput from "./components/TodoInput.vue";
import TodoList from "./components/TodoList.vue";
import TodoFooter from "./components/TodoFooter.vue";

export default {
  name: "app",
  data: function() {
    return {
      todoItems: []
    };
  },
  created() {
    if (localStorage.length > 0) {
      for (var i = 0; i < localStorage.length; i++) {
        if (localStorage.key(i) !== "loglevel:webpack-dev-server") {
          this.todoItems.push(
            JSON.parse(localStorage.getItem(localStorage.key(i)))
          );
        }
      }
    }
  },
  methods: {
    addTodo: function(newTodoItem) {
      if (newTodoItem !== "") {
        var obj = { completed: false, item: newTodoItem };
        this.todoItems.push(obj);
        localStorage.setItem(newTodoItem, JSON.stringify(obj));
      }
    },
    removeTodo: function(todoItem, index) {
      localStorage.removeItem(todoItem.item);
      this.todoItems.splice(index, 1);
    },
    toggleComplete: function(todoItem, index) {
      this.todoItems[index].completed = !this.todoItems[index].completed;
      localStorage.removeItem(todoItem.item);
      localStorage.setItem(todoItem.item, JSON.stringify(todoItem));
    },
    clearTodo: function() {
      localStorage.clear();
      this.todoItems = [];
    }
  },
  components: {
    TodoHeader, //파스칼 케이스
    TodoInput,
    TodoList,
    TodoFooter
  }
};
</script>

<style>
body {
  text-align: center;
  background-color: #f6f6f6;
}
input {
  border-style: groove;
  width: 200px;
}
button {
  border-style: groove;
}
.shadow {
  box-shadow: 5px 10px 10px rgba(0, 0, 0, 0.03);
}
</style>